from re import match

def common_prefix_length(A,B):
    L = min(len(A),len(B))
    for i in range(L):
        if A[i] != B[i]: return i
    return L

def fizzbuzz(N,D,S):
    answer = []
    for n in range(1,N+1):
        l = ''
        for d,s in zip(D,S):
            if n % d == 0: l += s
        if l == '': l = str(n)
        answer.append(l)
    return answer

T = int( input() )
for t in range(T):
    input()
    input()
    tokens = input().split()
    N = len(tokens)

    answer = 0

    # case k = 0
    answer = max( answer, common_prefix_length( tokens, fizzbuzz(N,[],[]) ) )

    # case k = 1
    for n in range(N):
        if match(r'^[a-z]{4}$', tokens[n]):
            answer = max( answer, common_prefix_length( tokens, fizzbuzz(N,[n+1],[tokens[n]]) ) )
            break

    # case k = 2
    for n in range(N):
        if match(r'^[a-z]{4}$', tokens[n]):
            for m in range(n+1,N):
                second = ''
                if match(r'^[a-z]{4}$', tokens[m]): second = tokens[m]
                if match(r'^[a-z]{8}$', tokens[m]): second = tokens[m][4:]
                if second != '':
                    answer = max( answer, common_prefix_length( tokens, fizzbuzz(N,[n+1,m+1],[tokens[n],second]) ) )
            break
    
    print(answer)
